var express = require('express');
var bodyParser = require('body-parser');
var auth = require('http-auth');
var consolidate = require('consolidate');

var app = express();

var basic = auth.basic({
    realm: "Connector area",
    file: '.htpasswd'
});

// HTML template engine config
app.engine('html', consolidate.handlebars);
app.set('view engine', 'html');

// Web server configuration (using Express middlewares)
app.use('/api/v1', express.static('public'));
app.use(auth.connect(basic));
app.use('/api/v1', function (req, res, next) {
    if (req.method == 'POST' || req.method == 'PUT') {
        var contentType = req.headers['content-type'];

        if (!contentType || contentType.indexOf('application/json') !== 0)
            return res.sendStatus(400);
    }
    next();
});
app.use(bodyParser.json());

// Routes configuration for those prefixed with '/api'
app.use('/api/v1', require('./routes'));

module.exports = app;
