var app = require('./connector');
var events = require('./events');
var defines = require('./defines');
const WebSocket = require('ws');

const wsserver = new WebSocket.Server({
    noServer: true,
    path: "/ws/events",
});

const server = app.listen(defines.listen_port);
server.on("upgrade", (request, socket, head) => {
    wsserver.handleUpgrade(request, socket, head, (websocket) => {
        wsserver.emit("connection", websocket, request);
    });
});

wsserver.on("connection", events.addWsConnection);

console.log("Connector is up and listening on port", defines.listen_port);

function randomInteger (low, high) {
    return Math.floor(Math.random() * (high - low + 1) + low);
}

// Sending a motion event every 15 sec
setInterval(function () {
    events.addMotionEvent();
}, 15000);

// Sending "demo.event1" every 4 seconds
setInterval(function () {
    events.addCustomEvent('demo.event1');
}, 4000);

// Sending "demo.event2" with a custom argument every 6 seconds
setInterval(function () {
    events.addCustomEvent('demo.event2', randomInteger(100, 999));
}, 6000);

// Uncomment to also have bounding events every 200ms
/*setInterval(function () {
    events.addBoundingBox();
}, 200);
*/
